#include <iostream>                // std::cout
#include <functional>              // std::bind
#include <random>
#include <vector>
#include <cstring>
#include <algorithm>
using namespace std;

class Histograf
{
public:
	Histograf( unsigned step) : step(step), counter(0) {}
	unsigned operator()(int val, bool last = false)
	{
		counter++;
		if (last)
			cout << "last element in the series: " << val << endl;
		return val / step;
	}
	unsigned inline changed( void ) { return counter; }
private:
	unsigned step;
	unsigned counter;
};

size_t steps;                                                            // number of clasters

void show( unsigned change, unsigned arr[] )
{
	cout << "there was " << change << " calls : ";
	for (size_t i = 0; i < steps; i++)
		cout << "| " << arr[ i ] << " ";
	cout << " |" << endl << endl;
}

int main( int argc, char *argv[] )
{
	size_t range = 100;                                                 // [0 ... range) - range of value
	if (argc > 1) 
	{
		if (0 == strcmp( argv[1], "-h" ) )
		{
			cout << "usage: " << argv[0] << " [<range>] [steps] [[+/-]<length>]" << endl;
			return 0;
		}
		else if (atol( argv[1] ) > 0)
			range  = atol( argv[1] );
	}
	steps = (argc > 2 && atol( argv[2] ) > 0 ) ? atol( argv[2] ) : 4;
	long limit = 100;                                                   // number of digits in series
	limit = (argc > 3 && atol( argv[3] ) != 0 ) ? atol( argv[3] ) : 100;
	bool print = ( limit < 0 );
	limit = abs( limit );
	cout << "size of sequence: " << limit << endl;
	std::default_random_engine generator;                               // construct a trivial random generator engine
	std::uniform_int_distribution<int> distribution( 0, range - 1 );    // https://www.cplusplus.com/reference/random/
	auto dice = std::bind ( distribution, generator );                  // function for generates number in the range 0..range
	dice();                                                             // first alwais 0
	vector<int> v( limit );
	for ( auto &u: v )
		u = dice(); 
	if (print) {                                                         //debuging output
		cout << "< ";
		for( auto& i: v ) cout << i << " ";
		cout << ">" << endl << endl;
	}
	unsigned hist[ steps ];                                              // Varianle-Length Array (ISO/IEC 9899:1999)
//---------------------------------------------------------
	for (size_t i = 0; i < steps; i++ ) hist[ i ] = 0;
	Histograf hi1( range / steps );
	for ( int& i : v )
		hist[ hi1( i ) ]++;
	show( hi1.changed(), hist );
//---------------------------------------------------------
	for (size_t i = 0; i < steps; i++ ) hist[ i ] = 0;
	Histograf hi2( range / steps );
	for ( auto i = v.begin(); i != v.end(); i++ )
		hist[ hi2( *i, i + 1 == v.end() ) ]++;
	show( hi2.changed(), hist );
//---------------------------------------------------------
	for (size_t i = 0; i < steps; i++ ) hist[ i ] = 0;
	Histograf hi3( range / steps );
	for_each( v.begin(), v.end(), hi3 );
	show( hi3.changed(), hist );
//---------------------------------------------------------
}
